<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>polylib: homogenization.c Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<!-- Generated by Doxygen 1.6.1 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="main.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.html"><span>File&nbsp;List</span></a></li>
      <li><a href="globals.html"><span>File&nbsp;Members</span></a></li>
    </ul>
  </div>
<h1>homogenization.c</h1><a href="homogenization_8c.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">    This file is part of PolyLib.</span>
<a name="l00003"></a>00003 <span class="comment"></span>
<a name="l00004"></a>00004 <span class="comment">    PolyLib is free software: you can redistribute it and/or modify</span>
<a name="l00005"></a>00005 <span class="comment">    it under the terms of the GNU General Public License as published by</span>
<a name="l00006"></a>00006 <span class="comment">    the Free Software Foundation, either version 3 of the License, or</span>
<a name="l00007"></a>00007 <span class="comment">    (at your option) any later version.</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">    PolyLib is distributed in the hope that it will be useful,</span>
<a name="l00010"></a>00010 <span class="comment">    but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00011"></a>00011 <span class="comment">    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the</span>
<a name="l00012"></a>00012 <span class="comment">    GNU General Public License for more details.</span>
<a name="l00013"></a>00013 <span class="comment"></span>
<a name="l00014"></a>00014 <span class="comment">    You should have received a copy of the GNU General Public License</span>
<a name="l00015"></a>00015 <span class="comment">    along with PolyLib.  If not, see &lt;http://www.gnu.org/licenses/&gt;.</span>
<a name="l00016"></a>00016 <span class="comment">*/</span>
<a name="l00017"></a>00017 <span class="comment"></span>
<a name="l00018"></a>00018 <span class="comment">/** homogenization.c </span>
<a name="l00019"></a>00019 <span class="comment">    copyright 2004-2005 Bavo Nootaert</span>
<a name="l00020"></a>00020 <span class="comment">**/</span>
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#include &lt;<a class="code" href="assert_8h.html">assert.h</a>&gt;</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &lt;stdlib.h&gt;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &lt;string.h&gt;</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &lt;<a class="code" href="polylib_8h.html">polylib/polylib.h</a>&gt;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;<a class="code" href="homogenization_8h.html">polylib/homogenization.h</a>&gt;</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="keyword">static</span> <a class="code" href="struct__evalue.html">evalue</a> *<a class="code" href="homogenization_8c.html#af7a29828963075a67e9d7e95325ee972" title="homogenization.c copyright 2004-2005 Bavo Nootaert">dehomogenize_periodic</a>(<a class="code" href="struct__enode.html">enode</a> *en);
<a name="l00029"></a>00029 <span class="keyword">static</span> <a class="code" href="struct__evalue.html">evalue</a> *<a class="code" href="homogenization_8c.html#aca605e4d7473dda2b7499e9f7fb44f53" title="dehomogenize a polynomial.">dehomogenize_polynomial</a>(<a class="code" href="struct__enode.html">enode</a> *en);
<a name="l00030"></a>00030 
<a name="l00031"></a><a class="code" href="homogenization_8h.html#afc536ef283eb21ce3e2cbcd450d72969">00031</a> <a class="code" href="structpolyhedron.html">Polyhedron</a> *<a class="code" href="homogenization_8c.html#afc536ef283eb21ce3e2cbcd450d72969">homogenize</a>(<a class="code" href="structpolyhedron.html">Polyhedron</a> *P, <span class="keywordtype">unsigned</span> <a class="code" href="verif__ehrhart_8c.html#a89fd83aa168651629c012d8655635588">MAXRAYS</a>)
<a name="l00032"></a>00032 {
<a name="l00033"></a>00033     <a class="code" href="structmatrix.html">Matrix</a> M, *M2;
<a name="l00034"></a>00034     <span class="comment">/* Pretend P is a Matrix for a second */</span>
<a name="l00035"></a>00035     M.<a class="code" href="structmatrix.html#a16ad614d15c6e81c0041e877b623c72d">NbRows</a> = P-&gt;<a class="code" href="structpolyhedron.html#a2db05293e731089b9198d45cf027bd1c">NbConstraints</a>;
<a name="l00036"></a>00036     M.<a class="code" href="structmatrix.html#a68858fd3b57684ef38bdfce13c65d182">NbColumns</a> = P-&gt;<a class="code" href="structpolyhedron.html#a2a02cea8b7ba3dde415041b8b2373bc8">Dimension</a>+2;
<a name="l00037"></a>00037     M.<a class="code" href="structmatrix.html#a9c294a3fd4d273963e27a0c8cd819bd5">p_Init</a> = P-&gt;<a class="code" href="structpolyhedron.html#a3681618067c7bf2a0bd5e805871283f5">p_Init</a>;
<a name="l00038"></a>00038     M.<a class="code" href="structmatrix.html#a2c6d840d8d911ae95c2ae4fc96f4b5ba">p</a> = P-&gt;<a class="code" href="structpolyhedron.html#ab2691b8eb5d2dc43a509ac2094d2bc73">Constraint</a>;
<a name="l00039"></a>00039     M2 = <a class="code" href="Matop_8c.html#a7d43e9c44b8c49cd9a542102042ad72e">AddANullColumn</a>(&amp;M);
<a name="l00040"></a>00040     P = <a class="code" href="polyhedron_8c.html#aefb77665a187d751bdd44f106b12465e" title="Given a matrix of constraints (&amp;#39;Constraints&amp;#39;), construct and return a polyhedron...">Constraints2Polyhedron</a>(M2, MAXRAYS);
<a name="l00041"></a>00041     <a class="code" href="matrix_8c.html#afcb312b7c12a6997cd66964ecc34e1a6">Matrix_Free</a>(M2);
<a name="l00042"></a>00042     <span class="keywordflow">return</span> P;
<a name="l00043"></a>00043 }
<a name="l00044"></a>00044 <span class="comment"></span>
<a name="l00045"></a>00045 <span class="comment">/** dehomogenize an evalue. The last parameter (nb_param) is replaced by 1.</span>
<a name="l00046"></a>00046 <span class="comment">    This function is mutually recursive with dehomogenize_enode.</span>
<a name="l00047"></a>00047 <span class="comment">**/</span>
<a name="l00048"></a><a class="code" href="homogenization_8h.html#aad8cd6181d26eb3f13171462ee30b932">00048</a> <span class="keywordtype">void</span> <a class="code" href="homogenization_8c.html#aad8cd6181d26eb3f13171462ee30b932" title="dehomogenize an evalue.">dehomogenize_evalue</a>(<a class="code" href="struct__evalue.html">evalue</a> *ep, <span class="keywordtype">int</span> nb_param){
<a name="l00049"></a>00049   <a class="code" href="struct__evalue.html">evalue</a> *w;
<a name="l00050"></a>00050 <span class="comment"></span>
<a name="l00051"></a>00051 <span class="comment">  /** cannot dehomogenize rationals **/</span>
<a name="l00052"></a>00052   <span class="keywordflow">if</span> (<a class="code" href="source_2arith_2arithmetique_8h.html#a827532f2140ae2aa96e46baebae09723">value_zero_p</a>(ep-&gt;<a class="code" href="struct__evalue.html#ae4aada7b06d44dcbf9f4d2daf1834e29">d</a>)){
<a name="l00053"></a>00053 <span class="comment"></span>
<a name="l00054"></a>00054 <span class="comment">    /** we need to replace the last parameter **/</span>
<a name="l00055"></a>00055     <span class="keywordflow">if</span> (ep-&gt;x.p-&gt;pos == nb_param){
<a name="l00056"></a>00056       <span class="keywordflow">if</span> (ep-&gt;x.p-&gt;type == <a class="code" href="types_8h.html#a01e5f42033d0f34c1a182a25a7409feda3cb930eb7594d2236ab4fc6dd622c207">periodic</a> &amp;&amp; ep-&gt;x.p-&gt;size &gt; 1){
<a name="l00057"></a>00057         w = <a class="code" href="homogenization_8c.html#af7a29828963075a67e9d7e95325ee972" title="homogenization.c copyright 2004-2005 Bavo Nootaert">dehomogenize_periodic</a>(ep-&gt;x.p); 
<a name="l00058"></a>00058       }
<a name="l00059"></a>00059       <span class="keywordflow">else</span>{
<a name="l00060"></a>00060         w = <a class="code" href="homogenization_8c.html#aca605e4d7473dda2b7499e9f7fb44f53" title="dehomogenize a polynomial.">dehomogenize_polynomial</a>(ep-&gt;x.p);
<a name="l00061"></a>00061       }
<a name="l00062"></a>00062       <a class="code" href="ehrhart_8c.html#a96434ed8279f7999773fa3343cfe98b8" title="releases all memory referenced by e.">free_evalue_refs</a>(ep);
<a name="l00063"></a>00063       memcpy(ep, w, <span class="keyword">sizeof</span>(<a class="code" href="struct__evalue.html">evalue</a>));
<a name="l00064"></a>00064       free(w);
<a name="l00065"></a>00065     }
<a name="l00066"></a>00066     <span class="keywordflow">else</span>{<span class="comment"></span>
<a name="l00067"></a>00067 <span class="comment">      /** Not the last parameter. Recurse **/</span>
<a name="l00068"></a>00068       <a class="code" href="homogenization_8c.html#af91fee5e1af870b385e88405cf116652" title="dehomogenize all evalues in an enode.">dehomogenize_enode</a>(ep-&gt;x.p, nb_param);
<a name="l00069"></a>00069     }
<a name="l00070"></a>00070 
<a name="l00071"></a>00071   }
<a name="l00072"></a>00072 }
<a name="l00073"></a>00073 <span class="comment"></span>
<a name="l00074"></a>00074 <span class="comment">/** dehomogenize all evalues in an enode. </span>
<a name="l00075"></a>00075 <span class="comment">    This function is mutually recursive with dehomogenize_evalue.</span>
<a name="l00076"></a>00076 <span class="comment">**/</span>
<a name="l00077"></a><a class="code" href="homogenization_8h.html#af91fee5e1af870b385e88405cf116652">00077</a> <span class="keywordtype">void</span> <a class="code" href="homogenization_8c.html#af91fee5e1af870b385e88405cf116652" title="dehomogenize all evalues in an enode.">dehomogenize_enode</a>(<a class="code" href="struct__enode.html">enode</a> *<a class="code" href="vector_8c.html#aa45b2e3dcf291527c5aedc420819adfc">p</a>, <span class="keywordtype">int</span> nb_param){
<a name="l00078"></a>00078   <a class="code" href="struct__evalue.html">evalue</a> *temp;
<a name="l00079"></a>00079   <span class="keywordtype">int</span> i;
<a name="l00080"></a>00080   <span class="keywordflow">for</span> (i = 0; i &lt; p-&gt;<a class="code" href="struct__enode.html#aba9a89a7893638f2ad9d77c9d0247797">size</a>; i++){
<a name="l00081"></a>00081     <a class="code" href="homogenization_8c.html#aad8cd6181d26eb3f13171462ee30b932" title="dehomogenize an evalue.">dehomogenize_evalue</a>(&amp;p-&gt;<a class="code" href="struct__enode.html#a215794f8b8ab87573bd46f14a8e916d4">arr</a>[i], nb_param);
<a name="l00082"></a>00082   }
<a name="l00083"></a>00083 }
<a name="l00084"></a>00084 
<a name="l00085"></a>00085 <span class="comment"></span>
<a name="l00086"></a>00086 <span class="comment">/** return the 1st element of an enode representing a periodic **/</span>
<a name="l00087"></a><a class="code" href="homogenization_8c.html#af7a29828963075a67e9d7e95325ee972">00087</a> <span class="keyword">static</span> <a class="code" href="struct__evalue.html">evalue</a> *<a class="code" href="homogenization_8c.html#af7a29828963075a67e9d7e95325ee972" title="homogenization.c copyright 2004-2005 Bavo Nootaert">dehomogenize_periodic</a>(<a class="code" href="struct__enode.html">enode</a> *en){
<a name="l00088"></a>00088   <a class="code" href="struct__evalue.html">evalue</a> *w;
<a name="l00089"></a>00089   <a class="code" href="assert_8h.html#a07d17d6d5d1074c0969bc5d3c3d1d84a">assert</a>(en-&gt;<a class="code" href="struct__enode.html#a36787a943f0f24530a8934c48a69d282">type</a> == <a class="code" href="types_8h.html#a01e5f42033d0f34c1a182a25a7409feda3cb930eb7594d2236ab4fc6dd622c207">periodic</a>);
<a name="l00090"></a>00090   <a class="code" href="assert_8h.html#a07d17d6d5d1074c0969bc5d3c3d1d84a">assert</a>(en-&gt;<a class="code" href="struct__enode.html#aba9a89a7893638f2ad9d77c9d0247797">size</a> &gt; 1);
<a name="l00091"></a>00091   <a class="code" href="assert_8h.html#a07d17d6d5d1074c0969bc5d3c3d1d84a">assert</a>(<a class="code" href="source_2arith_2arithmetique_8h.html#a47d32925340d2dc99ef2d4215080a60d">value_notzero_p</a>(en-&gt;<a class="code" href="struct__enode.html#a215794f8b8ab87573bd46f14a8e916d4">arr</a>[1].<a class="code" href="struct__evalue.html#ae4aada7b06d44dcbf9f4d2daf1834e29">d</a>));
<a name="l00092"></a>00092   w = (<a class="code" href="struct__evalue.html">evalue</a>*)malloc(<span class="keyword">sizeof</span>(<a class="code" href="struct__evalue.html">evalue</a>));
<a name="l00093"></a>00093   <a class="code" href="source_2arith_2arithmetique_8h.html#af71a2ca0294a19cff0cdcbdcc052ee27">value_init</a>(w-&gt;<a class="code" href="struct__evalue.html#ae4aada7b06d44dcbf9f4d2daf1834e29">d</a>); <a class="code" href="source_2arith_2arithmetique_8h.html#af71a2ca0294a19cff0cdcbdcc052ee27">value_init</a>(w-&gt;x.n);
<a name="l00094"></a>00094   <a class="code" href="source_2arith_2arithmetique_8h.html#a864613888dc46f15679aa4f63e468f89">value_assign</a>(w-&gt;<a class="code" href="struct__evalue.html#ae4aada7b06d44dcbf9f4d2daf1834e29">d</a>, en-&gt;<a class="code" href="struct__enode.html#a215794f8b8ab87573bd46f14a8e916d4">arr</a>[1].<a class="code" href="struct__evalue.html#ae4aada7b06d44dcbf9f4d2daf1834e29">d</a>); <a class="code" href="source_2arith_2arithmetique_8h.html#a864613888dc46f15679aa4f63e468f89">value_assign</a>(w-&gt;x.n, en-&gt;<a class="code" href="struct__enode.html#a215794f8b8ab87573bd46f14a8e916d4">arr</a>[1].x.n);
<a name="l00095"></a>00095   <span class="keywordflow">return</span> w;
<a name="l00096"></a>00096 }
<a name="l00097"></a>00097 <span class="comment"></span>
<a name="l00098"></a>00098 <span class="comment">/** dehomogenize a polynomial. Assume the enode contains a polynomial in </span>
<a name="l00099"></a>00099 <span class="comment">    one variable, the homogenous parameter. </span>
<a name="l00100"></a>00100 <span class="comment">    Returns an new evalue, representing a rational.</span>
<a name="l00101"></a>00101 <span class="comment"> **/</span>
<a name="l00102"></a><a class="code" href="homogenization_8c.html#aca605e4d7473dda2b7499e9f7fb44f53">00102</a> <span class="keyword">static</span> <a class="code" href="struct__evalue.html">evalue</a> *<a class="code" href="homogenization_8c.html#aca605e4d7473dda2b7499e9f7fb44f53" title="dehomogenize a polynomial.">dehomogenize_polynomial</a>(<a class="code" href="struct__enode.html">enode</a> *en){
<a name="l00103"></a>00103   <a class="code" href="struct__evalue.html">evalue</a> *enn;
<a name="l00104"></a>00104   <a class="code" href="struct__evalue.html">evalue</a> *ev;
<a name="l00105"></a>00105   <span class="keywordtype">int</span> i;
<a name="l00106"></a>00106   <span class="keywordtype">double</span> som;
<a name="l00107"></a>00107   Value num, den, gcd, f1, f2;
<a name="l00108"></a>00108   <a class="code" href="assert_8h.html#a07d17d6d5d1074c0969bc5d3c3d1d84a">assert</a>(en-&gt;<a class="code" href="struct__enode.html#a36787a943f0f24530a8934c48a69d282">type</a> == <a class="code" href="types_8h.html#a01e5f42033d0f34c1a182a25a7409fedaa486649798da33c51389df14eaccd3ce">polynomial</a>);
<a name="l00109"></a>00109   som = 0;
<a name="l00110"></a>00110   <a class="code" href="source_2arith_2arithmetique_8h.html#af71a2ca0294a19cff0cdcbdcc052ee27">value_init</a>(num); <a class="code" href="source_2arith_2arithmetique_8h.html#af71a2ca0294a19cff0cdcbdcc052ee27">value_init</a>(den); <a class="code" href="source_2arith_2arithmetique_8h.html#af71a2ca0294a19cff0cdcbdcc052ee27">value_init</a>(gcd);
<a name="l00111"></a>00111   <a class="code" href="source_2arith_2arithmetique_8h.html#af71a2ca0294a19cff0cdcbdcc052ee27">value_init</a>(f1); <a class="code" href="source_2arith_2arithmetique_8h.html#af71a2ca0294a19cff0cdcbdcc052ee27">value_init</a>(f2);
<a name="l00112"></a>00112   <a class="code" href="source_2arith_2arithmetique_8h.html#a8cc56567a4a29271559ac0fd5f6c5bfa">value_set_si</a>(den, 1);
<a name="l00113"></a>00113 <span class="comment"></span>
<a name="l00114"></a>00114 <span class="comment">  /** enumerate over all coefficients (which are either periodic or rational,</span>
<a name="l00115"></a>00115 <span class="comment">      but not polynomial) **/</span>
<a name="l00116"></a>00116   <span class="keywordflow">for</span> (i = 0; i &lt; en-&gt;<a class="code" href="struct__enode.html#aba9a89a7893638f2ad9d77c9d0247797">size</a>; i++){
<a name="l00117"></a>00117     <span class="keywordflow">if</span> (<a class="code" href="source_2arith_2arithmetique_8h.html#a827532f2140ae2aa96e46baebae09723">value_zero_p</a>(en-&gt;<a class="code" href="struct__enode.html#a215794f8b8ab87573bd46f14a8e916d4">arr</a>[i].<a class="code" href="struct__evalue.html#ae4aada7b06d44dcbf9f4d2daf1834e29">d</a>)){
<a name="l00118"></a>00118       <span class="keywordflow">if</span> (en-&gt;<a class="code" href="struct__enode.html#a215794f8b8ab87573bd46f14a8e916d4">arr</a>[i].x.p-&gt;size &gt; 1)
<a name="l00119"></a>00119         ev = &amp;en-&gt;<a class="code" href="struct__enode.html#a215794f8b8ab87573bd46f14a8e916d4">arr</a>[i].x.p-&gt;arr[1];
<a name="l00120"></a>00120       <span class="keywordflow">else</span>
<a name="l00121"></a>00121         ev = &amp;en-&gt;<a class="code" href="struct__enode.html#a215794f8b8ab87573bd46f14a8e916d4">arr</a>[i].x.p-&gt;arr[0];
<a name="l00122"></a>00122     }
<a name="l00123"></a>00123     <span class="keywordflow">else</span>{
<a name="l00124"></a>00124       ev = &amp;en-&gt;<a class="code" href="struct__enode.html#a215794f8b8ab87573bd46f14a8e916d4">arr</a>[i];
<a name="l00125"></a>00125     }<span class="comment"></span>
<a name="l00126"></a>00126 <span class="comment">    /** add ev (fraction) to num/den **/</span>
<a name="l00127"></a>00127     <a class="code" href="source_2arith_2arithmetique_8h.html#ac9986d34264874727344f666079e2294">value_multiply</a>(f1, den, ev-&gt;x.n);
<a name="l00128"></a>00128     <a class="code" href="source_2arith_2arithmetique_8h.html#ac9986d34264874727344f666079e2294">value_multiply</a>(f2, num, ev-&gt;<a class="code" href="struct__evalue.html#ae4aada7b06d44dcbf9f4d2daf1834e29">d</a>);
<a name="l00129"></a>00129     <a class="code" href="source_2arith_2arithmetique_8h.html#aea216a0e750144f0e6eb9b0a82583739">value_addto</a>(num, f1, f2);
<a name="l00130"></a>00130     <a class="code" href="source_2arith_2arithmetique_8h.html#ac9986d34264874727344f666079e2294">value_multiply</a>(den, den, ev-&gt;<a class="code" href="struct__evalue.html#ae4aada7b06d44dcbf9f4d2daf1834e29">d</a>);
<a name="l00131"></a>00131   }
<a name="l00132"></a>00132   <span class="comment"></span>
<a name="l00133"></a>00133 <span class="comment">  /** simplify num/den **/</span>
<a name="l00134"></a>00134   <a class="code" href="source_2arith_2arithmetique_8h.html#a50a34e78517e58cd1c2494a99be1e62b">value_gcd</a>(gcd, num, den);
<a name="l00135"></a>00135   <a class="code" href="source_2arith_2arithmetique_8h.html#a4b01d50506e0c7691b69d57a87280f5d">value_divexact</a>(num, num, gcd);
<a name="l00136"></a>00136   <a class="code" href="source_2arith_2arithmetique_8h.html#a4b01d50506e0c7691b69d57a87280f5d">value_divexact</a>(den, den, gcd);
<a name="l00137"></a>00137 <span class="comment"></span>
<a name="l00138"></a>00138 <span class="comment">  /** create new evalue representing num/den**/</span>
<a name="l00139"></a>00139   enn = (<a class="code" href="struct__evalue.html">evalue</a>*)malloc(<span class="keyword">sizeof</span>(<a class="code" href="struct__evalue.html">evalue</a>));
<a name="l00140"></a>00140   <a class="code" href="source_2arith_2arithmetique_8h.html#af71a2ca0294a19cff0cdcbdcc052ee27">value_init</a>(enn-&gt;<a class="code" href="struct__evalue.html#ae4aada7b06d44dcbf9f4d2daf1834e29">d</a>); <a class="code" href="source_2arith_2arithmetique_8h.html#af71a2ca0294a19cff0cdcbdcc052ee27">value_init</a>(enn-&gt;x.n);
<a name="l00141"></a>00141   <a class="code" href="source_2arith_2arithmetique_8h.html#a864613888dc46f15679aa4f63e468f89">value_assign</a>(enn-&gt;<a class="code" href="struct__evalue.html#ae4aada7b06d44dcbf9f4d2daf1834e29">d</a>, den);
<a name="l00142"></a>00142   <a class="code" href="source_2arith_2arithmetique_8h.html#a864613888dc46f15679aa4f63e468f89">value_assign</a>(enn-&gt;x.n, num);
<a name="l00143"></a>00143 <span class="comment"></span>
<a name="l00144"></a>00144 <span class="comment">  /** cleanup **/</span>
<a name="l00145"></a>00145   <a class="code" href="source_2arith_2arithmetique_8h.html#ab9b282921e85a0527d462d331533d619">value_clear</a>(gcd);
<a name="l00146"></a>00146   <a class="code" href="source_2arith_2arithmetique_8h.html#ab9b282921e85a0527d462d331533d619">value_clear</a>(f1); <a class="code" href="source_2arith_2arithmetique_8h.html#ab9b282921e85a0527d462d331533d619">value_clear</a>(f2); 
<a name="l00147"></a>00147   <a class="code" href="source_2arith_2arithmetique_8h.html#ab9b282921e85a0527d462d331533d619">value_clear</a>(num); <a class="code" href="source_2arith_2arithmetique_8h.html#ab9b282921e85a0527d462d331533d619">value_clear</a>(den);
<a name="l00148"></a>00148 
<a name="l00149"></a>00149   <span class="keywordflow">return</span> enn;
<a name="l00150"></a>00150 }
<a name="l00151"></a>00151 <span class="comment"></span>
<a name="l00152"></a>00152 <span class="comment">/** dehomogenize a polyhedron. Assume the polyhedron p is homogenous.</span>
<a name="l00153"></a>00153 <span class="comment">    Returns a new polyhedron.</span>
<a name="l00154"></a>00154 <span class="comment">**/</span>
<a name="l00155"></a><a class="code" href="homogenization_8h.html#abab952bcd8adf0cc6af6a70823648266">00155</a> <a class="code" href="structpolyhedron.html">Polyhedron</a> *<a class="code" href="homogenization_8c.html#abab952bcd8adf0cc6af6a70823648266" title="dehomogenize a polyhedron.">dehomogenize_polyhedron</a>(<a class="code" href="structpolyhedron.html">Polyhedron</a> *<a class="code" href="vector_8c.html#aa45b2e3dcf291527c5aedc420819adfc">p</a>, <span class="keywordtype">int</span> <a class="code" href="testCompressParms_8c.html#a508eb31b6faa4939e1c32adaef41b8c8">maxRays</a>){
<a name="l00156"></a>00156   <a class="code" href="structmatrix.html">Matrix</a> *constr, *constrh;
<a name="l00157"></a>00157   <a class="code" href="structpolyhedron.html">Polyhedron</a> *ph;
<a name="l00158"></a>00158   <span class="keywordtype">int</span> i;
<a name="l00159"></a>00159   constr = <a class="code" href="polyhedron_8c.html#a69417a994cd682d0c391ecff6d223cd2">Polyhedron2Constraints</a>(p);
<a name="l00160"></a>00160   constrh = <a class="code" href="matrix_8c.html#ac0b29e1d99a2823ad00b5f2157879d80">Matrix_Alloc</a>(constr-&gt;<a class="code" href="structmatrix.html#a16ad614d15c6e81c0041e877b623c72d">NbRows</a>, constr-&gt;<a class="code" href="structmatrix.html#a68858fd3b57684ef38bdfce13c65d182">NbColumns</a> - 1);
<a name="l00161"></a>00161   <span class="keywordflow">for</span> (i = 0; i &lt; constr-&gt;<a class="code" href="structmatrix.html#a16ad614d15c6e81c0041e877b623c72d">NbRows</a>; i++){
<a name="l00162"></a>00162     <a class="code" href="vector_8c.html#ab6eca9ad03a2f4a60dd79182289e0e0b">Vector_Copy</a>(constr-&gt;<a class="code" href="structmatrix.html#a2c6d840d8d911ae95c2ae4fc96f4b5ba">p</a>[i], constrh-&gt;<a class="code" href="structmatrix.html#a2c6d840d8d911ae95c2ae4fc96f4b5ba">p</a>[i], constr-&gt;<a class="code" href="structmatrix.html#a68858fd3b57684ef38bdfce13c65d182">NbColumns</a> - 1);
<a name="l00163"></a>00163   }
<a name="l00164"></a>00164   ph = <a class="code" href="polyhedron_8c.html#aefb77665a187d751bdd44f106b12465e" title="Given a matrix of constraints (&amp;#39;Constraints&amp;#39;), construct and return a polyhedron...">Constraints2Polyhedron</a>(constrh, maxRays);
<a name="l00165"></a>00165   <a class="code" href="matrix_8c.html#afcb312b7c12a6997cd66964ecc34e1a6">Matrix_Free</a>(constr); <a class="code" href="matrix_8c.html#afcb312b7c12a6997cd66964ecc34e1a6">Matrix_Free</a>(constrh);
<a name="l00166"></a>00166   <span class="keywordflow">return</span> ph;
<a name="l00167"></a>00167 }
<a name="l00168"></a>00168 <span class="comment"></span>
<a name="l00169"></a>00169 <span class="comment">/** dehomogenize an enumeration. Replaces each validity domain and </span>
<a name="l00170"></a>00170 <span class="comment">    Ehrhart polynomial in the Enumeration en with the dehomogenized form.</span>
<a name="l00171"></a>00171 <span class="comment"> **/</span>
<a name="l00172"></a><a class="code" href="homogenization_8h.html#af6ed6707fca416fc2a848a43db72e3a1">00172</a> <span class="keywordtype">void</span> <a class="code" href="homogenization_8c.html#a06456b946001b8ddaf7203de4856abd7" title="dehomogenize an enumeration.">dehomogenize_enumeration</a>(<a class="code" href="struct__enumeration.html">Enumeration</a>* en, <span class="keywordtype">int</span> nb_params, <span class="keywordtype">int</span> <a class="code" href="testCompressParms_8c.html#a508eb31b6faa4939e1c32adaef41b8c8">maxRays</a>){
<a name="l00173"></a>00173   <a class="code" href="struct__enumeration.html">Enumeration</a> *en2;
<a name="l00174"></a>00174   <a class="code" href="structpolyhedron.html">Polyhedron</a> *vd;
<a name="l00175"></a>00175   <span class="keywordflow">for</span> (en2 = en; en2; en2 = en2-&gt;<a class="code" href="struct__enumeration.html#ad2fd42474e015c9abc6aea0e2bea08b8">next</a>) {
<a name="l00176"></a>00176     vd = <a class="code" href="homogenization_8c.html#abab952bcd8adf0cc6af6a70823648266" title="dehomogenize a polyhedron.">dehomogenize_polyhedron</a>(en2-&gt;<a class="code" href="struct__enumeration.html#a57e35419d63ab12898542ef58d8decac">ValidityDomain</a>, maxRays);
<a name="l00177"></a>00177     <a class="code" href="polyhedron_8c.html#a4ae97b9794e3a616f1d38c68e6515cc3">Polyhedron_Free</a>(en2-&gt;<a class="code" href="struct__enumeration.html#a57e35419d63ab12898542ef58d8decac">ValidityDomain</a>);
<a name="l00178"></a>00178     en2-&gt;<a class="code" href="struct__enumeration.html#a57e35419d63ab12898542ef58d8decac">ValidityDomain</a> = vd;
<a name="l00179"></a>00179     <a class="code" href="homogenization_8c.html#aad8cd6181d26eb3f13171462ee30b932" title="dehomogenize an evalue.">dehomogenize_evalue</a>(&amp;en2-&gt;<a class="code" href="struct__enumeration.html#aa499b062a10ce16356e9b52d25cae0d9">EP</a>, nb_params);
<a name="l00180"></a>00180   }
<a name="l00181"></a>00181 }
</pre></div></div>
<hr size="1"/><address style="text-align: right;"><small>Generated on Wed Nov 25 17:45:25 2009 for polylib by&nbsp;
<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.6.1 </small></address>
</body>
</html>
